<!DOCTYPE html>
<html lang="en">
<head>
    <title>QA - Базовый туториал по прикладному тестированию</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="node_modules/@shower/ribbon/styles/styles.css">
    <style>
        .shower {
            --slide-ratio: calc(16 / 9);
        }
    </style>
</head>
<body class="shower list">

    <header class="caption">
        <h1>QA - Базовый туториал по прикладному тестированию</h1>
    </header>

    <section class="slide" id="cover">
        <h2>QA - Базовый туториал по прикладному тестированию</h2>
        <figure>
            <img class="cover" src="pictures/cover.jpg" alt="Hands on the orange typewriter in a park">
        </figure>
        <style>
            #cover h2 {
                margin: 30px 0 0;
                color: white;
                text-align: center;
                font-size: 70px;
            }

            #cover p {
                margin: 10px 0 0;
                text-align: center;
                color: white;
                font-style: italic;
                font-size: 20px;
            }

            #cover p a {
                color: white;
            }
        </style>
    </section>
    <section class="slide">
        <h2>План</h1>
        <ol>
            <li>Теория</li>
            <li>Универсальный порядок тестирования</li>
            <li>Прикладные советы тестирования в WebCase</li>
        </ol>
    </section>
    <section class="slide">
        <h3>Этапы тестирования:</h3>
        <ol style="line-height: 1.3;">
            <li>Анализ продукта</li>
            <li>Работа с требованиями</li>
            <li>Разработка стратегии тестирования и планирование процедур контроля качества</li>
            <li>Создание тестовой документации</li>
            <li>Тестирование прототипа</li>
            <li>Основное тестирование</li>
            <li>Стабилизация</li>
            <li>Эксплуатация</li>
        </ol>
    </section>
    <section class="slide">
        <h3>Уровни Тестирования:</h3>
        <ol>
            <li>Модульное тестирование (Unit Testing)</li>
            <li>Интеграционное тестирование (Integration Testing)</li>
            <li>Системное тестирование (System Testing)</li>
            <li>Операционное тестирование (Release Testing)</li>
            <li>Приемочное тестирование (Acceptance Testing)</li>
        </ol>
    </section>
    <section class="slide">
        <h4>Модульное тестирование (Unit Testing)</h4>
        <p>Компонентное (модульное) тестирование проверяет функциональность и ищет дефекты в частях приложения, которые доступны и могут быть протестированы по-отдельности (модули программ, объекты, классы, функции и т.д.).
        </p>
    </section>
    <section class="slide">
        <h4>Интеграционное тестирование (Integration Testing)</h4>
        <p>Проверяется взаимодействие между компонентами системы после проведения компонентного тестирования.
        </p>
    </section>
    <section class="slide">
        <h4>Системное тестирование (System Testing)</h4>
        <p >Основной задачей системного тестирования является проверка как функциональных, так и не функциональных требований в системе в целом. При этом выявляются дефекты, такие как неверное использование ресурсов системы, непредусмотренные комбинации данных пользовательского уровня, несовместимость с окружением, непредусмотренные сценарии использования, отсутствующая или неверная функциональность, неудобство использования и т.д.
        </p>
    </section>
    <section class="slide">
        <h4>Операционное тестирование (Release Testing)</h4>
        <p style="line-height:1.3 ;font-size:0.9em;">Даже если система удовлетворяет всем требованиям, важно убедиться в том, что она удовлетворяет нуждам пользователя и выполняет свою роль в среде своей эксплуатации, как это было определено в бизнес моделе системы. Следует учесть, что и бизнес модель может содержать ошибки. Поэтому так важно провести операционное тестирование как финальный шаг валидации. Кроме этого, тестирование в среде эксплуатации позволяет выявить и нефункциональные проблемы, такие как: конфликт с другими системами, смежными в области бизнеса или в программных и электронных окружениях; недостаточная производительность системы в среде эксплуатации и др. Очевидно, что нахождение подобных вещей на стадии внедрения — критичная и дорогостоящая проблема. Поэтому так важно проведение не только верификации, но и валидации, с самых ранних этапов разработки ПО.
        </p>
    </section>
    <section class="slide">
        <h4>Приемочное тестирование (Acceptance Testing)</h4>
        <p>Формальный процесс тестирования, который проверяет соответствие системы требованиям и проводится с целью:
        </p>
        <ul>
            <li>определения удовлетворяет ли система приемочным критериям;</li>
            <li>вынесения решения заказчиком или другим уполномоченным лицом принимается приложение или нет.</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Подходы к интеграционному тестированию:</h3>
        <ul>
            <li>Снизу вверх (Bottom Up Integration)</li>
            <li>Сверху вниз (Top Down Integration)</li>
            <li>Большой взрыв («Big Bang» Integration)</li>
        </ul>
    </section>
    <section class="slide">
        <h4>Снизу вверх (Bottom Up Integration)</h4>
        <p>Все низкоуровневые модули, процедуры или функции собираются воедино и затем тестируются. После чего собирается следующий уровень модулей для проведения интеграционного тестирования. Данный подход считается полезным, если все или практически все модули, разрабатываемого уровня, готовы. Также данный подход помогает определить по результатам тестирования уровень готовности приложения.</p>
    </section>
    <section class="slide">
        <h4>Сверху вниз (Top Down Integration)</h4>
        <p>Вначале тестируются все высокоуровневые модули, и постепенно один за другим добавляются низкоуровневые. Все модули более низкого уровня симулируются заглушками с аналогичной функциональностью, затем по мере готовности они заменяются реальными активными компонентами. Таким образом мы проводим тестирование сверху вниз.</p>
    </section>
    <section class="slide">
        <h4>Большой взрыв («Big Bang» Integration)</h4>
        <p>Все или практически все разработанные модули собираются вместе в виде законченной системы или ее основной части, и затем проводится интеграционное тестирование. Такой подход очень хорош для сохранения времени. Однако если тест кейсы и их результаты записаны не верно, то сам процесс интеграции сильно осложнится, что станет преградой для команды тестирования при достижении основной цели интеграционного тестирования.</p>
    </section>
    <section class="slide">
        <h3>Методы тестирования:</h3>
        <ul style="line-height: 1.3em;">
            <li><b>Белый ящик</b> – “White box” QA Engineer предстоит работа с кодом и его логикой внутренней работы.</li>
            <li><b>Черный ящик </b>– “Black box” Процесс исследования ПО на баги осуществляется путем генерации тестовых случаев исходя из анализа функциональной спецификации (документ, который описывает желаемые характеристики системы и итоговый результат) или определенных элементов системы.</li>
            <li><b>Серый ящик</b> – “Grey box” Стоит, отметить, что данный метод сочетает в себе подходы к тестированию “белого и черного ящиков”.  То есть, QA Engineer смотрит на систему опираясь на метод “Black box” и анализирует известные данные о ней.</li>
        </ul>
    </section>
    <section class="slide">
        <h2>Базовый туториал по тестированию</h2>
        <p class="note next">Получил теорию, но как применить?</p>
        <p class="note next">Как начать тестировать после изучения курса?</p>
    </section>
    <section class="slide">
        <h2>Универсальная схема для тестирования веб-приложений</h2>
        <p style="line-height: 1.3em;">
            <span class="next">GUI</span>
            <span class="next">— >Functional</span>
            <span class="next">— >Usability</span>
            <span class="next">— >Security</span>
            <span class="next">— >Performance (Load/Stress/Recovery)</span>
            <span class="next">— >Configuration</span>
        </p>
    </section>
    <section class="slide">
        <h3>GUI</h3>
        <p>Тестирование GUI является процесс тестирования графического пользовательского интерфейса системы из тестируемого приложения. Тестирование GUI участвует проверку экранов с элементами управления, такими как кнопки меню, иконка и все виды баров – панели инструментов, панели меню, диалоговым окном и т.д.
        </p>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Проверьте все элементы GUI для размера, положения, ширины, длины и акцепта символов или цифр. Например, вы должны быть в состоянии внести свой вклад в соответствующие поля ввода.</li>
            <li>Убедитесь, что вы можете выполнить намеченную функциональность приложения с помощью графического интерфейса</li>
            <li>Проверить Сообщения об ошибках отображаются правильно</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Проверьте, четкое разграничение различных участков на экране </li>
            <li>Проверьте шрифт, используемый в приложении для чтения</li>
            <li>Проверьте выравнивание текста собственно</li>
            <li>Проверьте цвет шрифта и предупреждающие сообщения эстетично</li>
            <li>Убедитесь, что изображения имеют хорошую прозрачность </li>
            <li>Убедитесь, что изображения правильно выровнены </li>
        </ul>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Сравнение с макетом</li>
            <li>Появление курсора — довольно часто мы забываем проверить, появляется ли вообще и как выглядит курсор в полях ввода, на кликабельных элементах  </li>
            <li>Кодировка (UTF8...)</li>
            <li>Заголовки по всему приложению должны быть приведены к одному стандарту</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Title страницы — о нем мы тоже часто забываем, также как и разработчики</li>
            <li>Back button — достаточно часто встречается ошибка при переходе на какую-то страницу и нажатии на браузерную кнопку Back, предыдущая страница крашится или возврат на нее вовсе не осуществляется</li>
            <li>Кроссбраузерность — одна и та же страница может выглядеть по-разному в разных браузерах </li>
        </ul>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Проверьте расположение элементов графического интерфейса для различного разрешения экрана</li>
            <li>Обозначение возможности переноса элементов</li>
            <li>Фавикон — такая маленькая незначительная вещица, но может изрядно подпортить впечатление пользователя (в моей практике были случаи, когда разработчики или дизайнеры шаблона оставляли фавикон с логотипом своей компании на сайте у заказчика)  </li>
        </ul>
    </section>
    <section class="slide">
        <h3>Основные моменты тестирования GUI</h3>
        <ul>
            <li>Браузерные расширения, которые могут влиять на внешний вид приложения (например, AdBlock) — пробуем включить и отключить</li>
            <li>Проверяем Scroll</li>
            <li>Проверить контент при отключенных (режим WebDeveloper) изображениях  </li>
        </ul>
    </section>
    <section class="slide">
        <p>Тестирование локализации позволяет проверить насколько хорошо адаптирован продукт для определенной целевой аудитории в соответствии с ее культурными особенностями. Как правило, здесь рассматривается культурный и языковой аспекты, в частности перевод пользовательского интерфейса и соответствующей документации и файлов на другой язык, а также форматы валют, чисел, времени и телефонных номеров, и др.</p>
    </section>
    <section class="slide">
        <h3>Functional</h3>
        <p>Самый простой способ подготовиться к функциональному тестированию — это выписать список элементов вашего приложения и написать их целевое назначение («зачем?»).</p>
    </section>
    <section class="slide">
        <h3>Functional-Кнопки:</h3>
        <ul>
            <li>Enter должна срабатывать как submit;</li>
            <li>Tab должен переводить курсор на следующий элемент.</li>
        </ul>
        <h3>Functional-Сообщения об ошибках:</h3>
        <ul>
            <li>пробуем отключить в настройках браузера.</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Functional-Поля ввода:</h3>
        <ul>
            <li>trimming («убирание») пробелов в полях ввода;</li>
            <li>пустота/пробелы в поле ввода;</li>
            <li>все способы редактирования (Insert, Delete, Backspace, Ctrl+C/V/X/Z и т. д.);</li>
            <li>дроби ( 1.5 | 1,5 | ⅕).</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Functional-Поиск:</h3>
        <ul>
            <li>wildcard symbols (* | ?);</li>
            <li>написание поискового запроса слитно | раздельно | через дефис должно вести к одному результату;</li>
            <li>ввод текста в другой раскладке.</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Functional-Календарь:</h3>
        <ul>
            <li>31 июня;</li>
            <li>29 февраля + не высокосный год;</li>
            <li>прошлое/будущее (например, купить билет на уже прошедшее число).</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Functional-Время:</h3>
        <ul>
            <li>синхронизация с сервером (на сервере приложения может быть выставлено другое время, отличающееся от таймзоны пользователя);
                временные зоны.</li>
        </ul>
        <h3>Functional-E-mail:</h3>
        <ul>
            <li>логин (63 символа) @ домен (253 символа (может быть ip)).</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Functional-Всплывающие окна / подсказки:</h3>
        <ul>
            <li>пробуем закрыть разными способами (нажатие на кнопку (если есть), на «крестик», клавишей ESC, просто нажатием в другую область экрана);</li>
            <li>рефреш страницы особенно в момент запроса на сервер (например, совершение транзакции по покупке) иногда может приводить к появлению ошибок.</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Usability</h3>
        <p>За внешним видом и функциональностью следует удобство (Usability). Не менее важная часть, так как от нее зависит, будет ли востребован ваш продукт вообще. О каких моментах нужно помнить при тестировании usability веб-приложения?</p>
    </section>
    <section class="slide">
        <h3>Usability-основные моменты</h3>
        <ul>
            <li>Соответствует ли приложение ожиданиям конечного пользователя;</li>
            <li>Логичность интерфейса;</li>
            <li>Самое нужное «сверху»;</li>
            <li>Продуманная навигация;</li>
            <li>Локализация (да, да, она относится и сюда тоже);</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Usability-основные моменты</h3>
        <ul>
            <li>Совместимость с другим софтом (соцсети) и железом;</li>
            <li>Информативность (сообщения / обязательные поля);</li>
            <li>Возможность отмены действий пользователя;</li>
            <li>Help — должна быть инструкция, как работать с приложением;</li>
            <li>Возможность печати (если нужно).</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Security</h3>
        <ul style="line-height: 1.3em;">
            <li>Начинаем всегда с составления матрицы уровней доступа;</li>
            <li>Конфиденциальность — никто не может получить доступ к данным несанкционированно;</li>
            <li>Целостность данных:
                <ol type="a">
                    <li>возможность восстановить данные в полном объеме при их повреждении;</li>
                    <li>доступ на изменение информации только определенной категории пользователей.</li>
                </ol>
            </li>
        </ul>
    </section>
    <section class="slide">
        <h3>Performance</h3>
        <ul style="line-height: 1.3em;">
            <li>Имитируем нагрузку пользователями (JMeter);</li>
            <li>Пробуем загрузить большие объемы данных, файлы, медиа;</li>
            <li>Нагружаем БД;</li>
            <li>Понижаем скорость инета (NetLimiter);</li>
            <li>Понижаем скорость передачи данных (Throttling);</li>
            <li>Тестируем восстановление системы после падений.</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Configuration</h3>
        <ul>
            <li>Берем у разработчиков/заказчика список софта и железа, на котором и с которым должно работать наше приложение.</li>
            <li>Думаем над тем, с чем еще взаимодействует приложение (например соцсети, почта, возможно, камера на телефоне и т. п.).</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Configuration</h3>
        <ul>
            <li>Выписываем это все в список (ОС, браузеры, их версии для ПК, мобильных телефонов, планшетов, также (если это важно) выписываем на каком разрешении или с какими настройками (например, для камеры съемка в режиме HD) нужно проводить тестирование).</li>
            <li>Далее можем использовать метод классов эквивалентности, pairwise или просто руководствуемся тем, что есть в наличии, и настраиваем тестовое окружение с нужными конфигурациями.</li>
        </ul>
    </section>
    <section class="slide">
        <p>Если упростить все выше перечисленное</p>
        <p>
            <span class="next">Внешнее</span>
            <span class="next">— > Внутренее</span>
            <span class="next">— >Стойкость</span>
            <span class="next">— >Взаимодействие</span>
        </p>
    </section>
    <section class="slide">
        <p>Внешнее — проверка внешнего вида и функций, которые доступны только обычному пользователю (GUI, Usability).</p>
        <p>Внутреннее — все функции приложения (Functional).</p>
        <p>Стойкость — сюда мы отнесем устойчивость приложения к нагрузкам и к попыткам нарушить его безопасность (Security, Performance (load/stress/recovery)).</p>
        <p>Взаимодействие — работа приложения с другим софтом и железом (Configuration).</p>
    </section>
    <section class="slide">
        <h2>Советы по тестированию</h2>
    </section>
    <section class="slide">
        <h3>Советы по тестированию - ТЗ</h2>
        <ul>
            <li>Понять основную идею.</li>
            <li>Выделять основной функционал: статусы, классы пользователей, алгоритмы, уведомления</li>
            <li>Создать вспомогательные артефакты</li>
        </ul>
    </section>
    <section class="slide">
        <h3>Советы - Цикличность тестирования</h2>
        <p>
            <span class="next">Смоук тестирование</span>
            <span class="next">->Регресс</span>
            <span class="next">->Тестирование</span>
        </p>
    </section>
    <section class="slide">
        <h3>Советы - Смоук тестирование</h3>
        <p style="line-height: 1.3em;">Первый шаг непосредственно тестирования — смоук-тест: оценка на то, что приложение или его новая часть вообще готовы к проверке. Смоук-тест — это проверка того, запускается ли приложение или конкретная функция в принципе.</p>
    </section>
    <section class="slide">
        <h3>Советы - Регресс</h3>
        <p style="line-height: 1.3em;">Регрессионное тестирование хорошо тем, что оно позволяет найти ошибки даже в тех местах, где раньше всё было в порядке. Это происходит благодаря тому что регресс — это оценка функционала на стандартный набор кейсов при внедрении каждого нового модуля и каждого изменения приложения. Ведь, когда разработчики добавляют новый функционал может быть повреждена текущая версия или новая фича может вступать в конфликт с уже существующими.</p>
    </section>
    <section class="slide">
        <p><b>Баг имеет свойство возвращаться</b></p>
        <p>Баги найденные при тестировании могут повторяться несколько раз в течении разработки</p>
        <p class="note">Баг повторившийся 2 раза стоит проверять при регресс-тестировании</p>
    </section>
    <section class="slide">
        <h3>Советы - Идентификация бага в разделе Network</h3>
        <p>Идентифицировать баги только визуальным путем - сложно и не продуктивно. Большую помощь окажет вкладка Network в Dev-tools</p>
        <p>Вкладка Network позволяет наблядать за жизненным циклом запросов.</p>
    </section>
    <section class="slide">
        <h3>Советы - Dev Tools - Network</h3>
        <p>Запросы на сервер отправляються двумя путями</p>
        <ol>
            <li>Переход по ссылке</li>
            <li>Отправка с помощью js запроса</li>
        </ol>
        <p>Если разобрать эти запросы мы увидим следующее.</p>
    </section>
    <section class="slide">
        <h3>Советы - Dev Tools - Network</h3>
        <p>Запросы условно можно поделить на два типа:</p>
        <ol>
            <li>запрос->сервер->ответ->js</li>
            <li>js -> запрос -> сервер -> ответ -> js</li>
        </ol>
        <p>Зная схему запроса и открыв панель Network мы можем проанализировать коды ответов сервера и понять кто ответственный за баг</p>
    </section>
    <section class="slide">
        <h2>Самые распрастраненные коды ответов</h2>
        <table style="font-size: 0.9em;line-height: 1.3em;">
        <tr>
            <th scope="col">Код</th>
            <th style="padding-left: 20px;">Описание</th>
        </tr>
        <tr>
            <th scope="row">200</th>
            <td style="padding-left: 20px;">"Успешно". Запрос успешно обработан.</td>
        </tr>
        <tr>
            <th scope="row">400</th>
            <td style="padding-left: 20px;">"Плохой запрос". Этот ответ означает, что сервер не понимает запрос из-за неверного синтаксиса.</td>
        </tr>
        <tr>
            <th scope="row">403</th>
            <td style="padding-left: 20px;">"Запрещено". У клиента нет прав доступа к содержимому, поэтому сервер отказывается дать надлежащий ответ. </td>
        </tr>
        <tr>
            <th scope="row">404</th>
            <td style="padding-left: 20px;">"Не найден". Сервер не может найти запрашиваемый ресурс. Код этого ответа, наверно, самый известный из-за частоты его появления в вебе.</td>
        </tr>
        <tr>
            <th scope="row">500</th>
            <td style="padding-left: 20px;">"Внутренняя ошибка сервера". Сервер столкнулся с ситуацией, которую он не знает как обработать.</td>
        </tr>
        </table>
    </section>
    <section class="slide">
        <h2>Причины 200, 400</h2>
        <table style="font-size: 0.9em;line-height: 1.3em;">
        <tr>
            <th scope="col">Код</th>
            <th style="padding-left: 20px;">Описание</th>
        </tr>
        <tr>
            <th scope="row">200</th>
            <td style="padding-left: 20px;">Сервер говорит что все ок, но что то работает не правильно</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 1: На сервере есть api которое в зависимости от параметров отправляет объекты одинаковой структуры. Фронт из-за невнимательности отправляет корректный запрос с не теми переменными. В результате ошибок нет, но получаем баг.</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 2: Получаем ответ с кодом 200, но в консоли ошибки js.</td>
        </tr>
        <tr>
            <th scope="row">400</th>
            <td style="padding-left: 20px;">Есть сложности в определении ответственности.</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 1: в запросе js нет переменной</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 2: Расхождение front и back в протоколе передачи данных</td>
        </tr>
        </table>
    </section>
    <section class="slide">
        <h2>Причины 403, 500</h2>
        <table style="font-size: 0.9em;line-height: 1.3em;">
        <tr>
            <th scope="col">Код</th>
            <th style="padding-left: 20px;">Описание</th>
        </tr>
        <tr>
            <th scope="row">403</th>
            <td style="padding-left: 20px;">Пример 1: После нажатия какой либо кнопки или вследствии работы js. Верстка или js не учитывает права тек. пользователя или back ошибся с назначением прав.</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 2: Переход по url. Пользователь не обладает правами либо выставленны не правильные права.</td>
        </tr>
        <tr>
            <th scope="row">500</th>
            <td style="padding-left: 20px;">Пример 1: Если был запрос через Ajax, то ошибка будет в консоли</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 2: Если через обычный запрос, то будет html</td>
        </tr>
        </table>
    </section>
    <section class="slide">
        <h2>Причины 404, js</h2>
        <table style="font-size: 0.9em;line-height: 1.3em;">
        <tr>
            <th scope="col">Код</th>
            <th style="padding-left: 20px;">Описание</th>
        </tr>
        <tr>
            <th scope="row">404</th>
            <td style="padding-left: 20px;">Пример 1: Страница загружена, при нажатии кнопок или работе js возникает ошибка в консоле. Чаще всего такое случаеться с файлами. Они номинально существуют, но отсутствуют на диске</td>
        </tr>
        <tr>
            <th scope="row"></th>
            <td style="padding-left: 20px;">Пример 2: Осущевстляя переход по url получаем 404. Данный ресурс не сущевствует либо спрятан от пользователей с любым уровнем прав.</td>
        </tr>
        <tr>
            <th scope="row">js</th>
            <td style="padding-left: 20px;">Могут возникать при загрузке страницы, использование функций с пустыми формами, использование функций.</td>
        </tr>
        <tr>
            <th scope="row">Отсутствие запроса</th>
            <td style="padding-left: 20px;">Активирование эл. интерфейса либо не нуждаеться в запросе для работы, либо еще не функционирует</td>
        </tr>
        </table>
    </section>
    <section class="slide">
        <h3>На что обратить внимание при тестировании проектов на Django и WordPress?</h3>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Формы </span><span class="next">- Сохранение данных, обязательные на сервере\фронте, отрицательные значения, экранирование, перепрыгивание(таб), консолидированность, логика(не противоречивость полей) полей.</span></li>
            <li><span class="next">Уровни доступа</span><span class="next">- Права пользователей, зарезервированные данные(email)</span></li>
            <li><span class="next">Статусы</span><span class="next">- Логика статусов</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Мета - сео</span><span class="next">- Title, h1-3, description, фавикон</span></li>
            <li><span class="next">Верстка</span><span class="next">- Чек-листы верстки</span></li>
            <li><span class="next">Юзабилити</span><span class="next">- Уменьшать количество кликов для получения результатов,Обращай внимание на дискомфорт, исключить ситуации работы в два окна</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Функции обработки данных</span><span class="next">- Причинами могут быть: некоректные данные, ошибка в логике функции.</span></li>
            <li><span class="next">Поиск, фильтры, сортировки</span></li>
            <li><span class="next">Локализация</span><span class="next">- Перевод; одинаковые форматы дат, валют; сообщения ошибок</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Действия с аккаутом</span><span class="next">- Создание, Авторизация, Востановление пароля, Смена почты.</span></li>
            <li><span class="next">Многократные запросы</span><span class="next">Кнопки, действия которые приводят к многократным запросам.</span></li>
            <li><span class="next">Баги манипулирование url</span><span class="next">- Манипулирование url, кнопка "Назад"</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Файлы</span><span class="next">-  Весом, расширением, разрешением</span></li>
            <li><span class="next">Сервисы</span></li>
            <li><span class="next">Цепочка действий</span><span class="next">- Некоторая последовательность действий(алгоритм), который предполагает состояния и пнреходы между состояниями.</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>Django</h3>
        <ul>
            <li><span class="next">Пагинация</span></li>
            <li><span class="next">Соотвецтвие разработки бизнесс процессу(адекватность)</span></li>
            <li><span class="next">Экономить время плагинами</span></li>
        </ul>
    </section>
    <section class="slide">
        <h3>WordPress</h3>
        <p><b>WordPress</b> - этой готовая СMS с поддержкой плагинов , что позволяет сэкономить время на разработку.</p>
        <p>Данную CMS используют для создания лендингов и небольших интернет-магазинов или сайтов-услуг.</p>
        <p>Так как разрабока на данной CMS в основном состоит из создания верстки и подключения готовых плагинов - тестирование упрощено</p>
    </section>
    <section class="slide">
        <h3>WordPress</h3>
        <p>Необходимо обратить внимание:</p>
        <div class="columns two">
            <ul>
                <li>Вёрстка</li>
                <li>Формы</li>
                <li>Менеджмент контента</li>
                <li>Кастомные поля</li>
                <li>Локализация</li>
            </ul>
            <ul>
                <li>SEO</li>
                <li>Функционал по ТЗ</li>
                <li>Уведомления</li>
                <li>Аккаунт</li>
            </ul>
        </div>
    </section>
    <section class="slide">
        <h3>Советы</h3>
        <p>1.Стройте стратегию тестирования в зависимости от доступного времени.</p>
        <p>2.При паралельном тестировании нескольких проектов пытайтесь уделять каждому время. Производительность в ущерб скурпулезности.</p>
        <p>3.Выделяйте время на ознакомление ТЗ и разработку доп. артефактов.</p>
        <p>4.Используйте напоминания.</p>
    </section>
    <section class="slide">
        <h3>Cases</h3>
        <p>В условиях WebCase нет возможности создавать полноценные пакеты тест-кейсов, но их написание позволяет больше понять проект и облегчить процесс тестирования. Лучше альтернативой будет создание кейсов в виде чек листов(если не по всем функциям, то хотя бы по основным функциям на котором завязан бизнесс-процесс).</p>
    </section>
    <section class="slide">
        <h3>Доп. артефакты</h3>
        <p>Если есть желание можно воспользоваться схемой-алгоритмом подбора артефактов для проекта</p>
        <p>
            <a href="https://drive.google.com/file/d/1dlJMnsHaYKwZHEVzkZs-dnr0lZUGZN38/view?usp=sharing">Схема</a>
        </p>
    </section>
    <section class="slide">
        <h3>Матрица ролей</h3>
        <img  style="max-height:300px" src="pictures\504e3f056517c2d56e5b42c5aec9c1f3.png" alt="">
    </section>
    <section class="slide">
        <h3>Диаграмма переходов состояний</h3>
        <img  style="max-height:300px" src="pictures\3mob(Стартова сторінка веб сайту).svg" alt="">
    </section>
    <section class="slide">
        <h3>Таблица принятия решений</h3>
        <img  style="max-height:300px" src="pictures\slide-39.jpg" alt="">
    </section>
    <section class="slide">
        <h2>Источники</h2>
        <ol style="line-height: 1.1em;font-size: 0.5;">
            <li><a href="https://habr.com/ru/post/279535/">Тестирование. Фундаментальная теория</a></li>
            <li><a href="https://skillup.ua/lp/%D1%87%D1%82%D0%BE-%D1%82%D0%B0%D0%BA%D0%BE%D0%B5-%D1%82%D0%B5%D1%81%D1%82%D0%B8%D1%80%D0%BE%D0%B2%D0%B0%D0%BD%D0%B8%D0%B5-%D0%BF%D1%80%D0%BE%D0%B3%D1%80%D0%B0%D0%BC%D0%BC%D0%BD%D0%BE%D0%B3%D0%BE/">White,Black,Grey-box</a></li>
            <li><a href="https://dou.ua/lenta/articles/scheme-for-qa/">Ничего не забыть: универсальная схема для тестирования веб-приложений</a></li>
            <li><a href="https://moluch.ru/th/8/archive/62/2630/">Тестирование графического интерфейса</a></li>
            <li><a href="https://habr.com/ru/company/netologyru/blog/334694/">Тестирование прототипов при разработке программного продукта</a></li>
            <li><a href="https://quality-lab.ru/blog/localization-testing/">Тестирование локализации</a></li>
            <li><a href="https://habr.com/ru/company/skillbox/blog/418889/">Гид по ручному тестированию приложений: преимущества, этапы и методологии</a></li>
            <li><a href="https://developer.mozilla.org/ru/docs/Web/HTTP/Status">Коды ответа HTTP</a></li>
            <li><a href="https://docs.google.com/spreadsheets/d/1jYp0i05t6uU0DHNFvnkb0oBqdMCJWxmNuS2_4WhxOuc/edit?usp=sharing">Чек-лист Вёрстки</a></li>
        </ol>
        <p>Спасибо за внимание</p>
        
    </section>
    
    <footer class="badge">
        <a href="https://github.com/shower/shower">Fork me on GitHub</a>
    </footer>

    <div class="progress"></div>

    <script src="node_modules/shower-core/shower.min.js"></script>
    <!-- Copyright © 3000 Yours Truly, Famous Inc. -->

</body>
</html>
